
#include "WinSocket.h"

#define BUFFER_SIZE 8191


SocketManager::SocketManager()
{
	WSAStartup(MAKEWORD(1,1), &m_WSADATA);
}


SocketManager::~SocketManager()
{
	WSACleanup();
}

bool SocketManager::FirstConnect(std::string address, unsigned short port)
{
    int recv_status;
    bool ret;
    char cbuff[BUFFER_SIZE]; 
    timeval tv;
    int retval;
    fd_set rfds;

    ret = false;
    memset(cbuff, 0, BUFFER_SIZE);

    memset(&m_dstAddr, 0, sizeof(m_dstAddr));
    m_dstAddr.sin_port = htons(port);
    m_dstAddr.sin_family = AF_INET;
    m_dstAddr.sin_addr.s_addr = inet_addr(address.c_str());

    m_sock = socket(AF_INET, SOCK_STREAM, 0);

    printf("Trying to connect to %s:%d \n", address.c_str(), port);
    if (connect(m_sock, (struct sockaddr *) &m_dstAddr, sizeof(m_dstAddr)) == -1) {
        std::cout << "connect is error IP:" << address.c_str() << " port:" << port << std::endl;
        return ret;
    }

    printf("waiting...\n");

    FD_ZERO(&rfds);
    FD_SET(m_sock, &rfds);

    tv.tv_sec = 3;
    tv.tv_usec = 0;

    retval = select(m_sock + 1, &rfds, NULL, NULL, &tv);

    if (retval == -1) {
        printf("select ERROR\n");
    } else {
        if (retval) {
            printf("data receive now\n");
            recv_status = recv(m_sock, cbuff, BUFFER_SIZE, 0);
            if (recv_status == 0 || recv_status == -1) {
                std::cout << "recv ERORR !!" << std::endl;
                closesocket(m_sock);
            } else {
                if (strncmp(cbuff, "HELLO", 5) == 0) {
                    std::cout << "Find HELLO" << std::endl;
                    ret = true;
                } else {
                    std::cout << "Not Find" << std::endl;
                }
            }
        } else {
            printf("5 seconds time out\n");
        }
    }

    return ret;
}

bool SocketManager::SendRequest(std::string request)
{
    send(m_sock, request.data(), request.length(), 0);
    return true;
}

std::string SocketManager::ReceiveData(void)
{
    int recv_status;
    char cbuff[BUFFER_SIZE];
    std::string receive;

    timeval tv;
    int retval;
	fd_set rfds;

    memset(cbuff, 0, BUFFER_SIZE);

    FD_ZERO(&rfds);
    FD_SET(m_sock, &rfds);

    tv.tv_sec = 5;
    tv.tv_usec = 0;

    retval = select(m_sock + 1, &rfds, NULL, NULL, &tv);

    if (retval == -1) {
        printf("select ERROR\n");
    } else {
        if (retval) {
            printf("data receive now\n");
            recv_status = recv(m_sock, cbuff, BUFFER_SIZE, 0);
            if (recv_status == 0 || recv_status == -1) {
                std::cout << "recv ERORR !!" << std::endl;
                closesocket(m_sock);
            }
        } else {
            printf("5 seconds time out\n");
        }
    }

    receive = cbuff;

    return receive;

}

void SocketManager::CuttingConnect(void)
{
    closesocket(m_sock);
    Sleep(3000);
}
